VERSION 5.00
Begin VB.Form MainForm 
   Caption         =   "Mini-Laser Driver Test"
   ClientHeight    =   930
   ClientLeft      =   5295
   ClientTop       =   4215
   ClientWidth     =   3585
   LinkTopic       =   "MainForm"
   LockControls    =   -1  'True
   ScaleHeight     =   930
   ScaleWidth      =   3585
   Begin VB.Timer tmrSN 
      Interval        =   1000
      Left            =   1890
      Top             =   0
   End
   Begin VB.CommandButton cmdExit 
      Cancel          =   -1  'True
      Caption         =   "&Exit"
      Height          =   375
      Left            =   2835
      TabIndex        =   1
      Top             =   525
      Width           =   675
   End
   Begin VB.TextBox txtCurrent 
      Alignment       =   2  'Center
      ForeColor       =   &H00000000&
      Height          =   330
      Left            =   105
      MaxLength       =   4
      TabIndex        =   0
      Text            =   "0"
      ToolTipText     =   "Enter number 0 to 2047 or use arrow keys."
      Top             =   525
      Width           =   645
   End
   Begin VB.Label lblSerNum 
      Height          =   585
      Left            =   0
      TabIndex        =   2
      Top             =   0
      Width           =   3495
   End
   Begin VB.Label lblMv 
      Caption         =   "0mA"
      Height          =   250
      Left            =   900
      TabIndex        =   3
      Top             =   600
      Width           =   960
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'Mini-Laser Driver test program,  Alan Stummer March '04.
' Based on Delcom Engineering sample program.
Option Explicit
DefVar A-Z
Function UpdateDAC()                                                         'Send the data with a Load (P1.3) low pulse.

  Dim Packet As PacketStructure
    
  If Not OpenDevice Then lblSerNum = lblSerNum.Tag                                                'OPEN THE DRIVER BOARD.
  txtCurrent.ForeColor = vbBlack

  On Local Error Resume Next
    
  Packet.MajorCmd = 10                                                                                 'write to device.
  Packet.MinorCmd = 10                                                           'write LSB to port 0 and MSB to port 1.
  Packet.DataLSB = Val(txtCurrent) Mod 256                                                            'DAC 0-7 (P0.0-7).
  Packet.DataMSB = Int(Val(txtCurrent) / 256) + 8                                      'DAC 8-10 with ~WE high (P1.0-3).
  Packet.Length = 0
  SendPacket Packet                                                                                   ' Send the Packet.
  
  Packet.DataMSB = Int(Val(txtCurrent) / 256)                                           'DAC 8-10 with ~WE low (P1.0-3).
  SendPacket Packet                                                                                   ' Send the Packet.
   
  Packet.DataMSB = Int(Val(txtCurrent) / 256) + 8                                      'DAC 8-10 with ~WE high (P1.0-3).
  SendPacket Packet                                                                                   ' Send the Packet.
  
  CloseDevice
  txtCurrent.SetFocus

End Function

Private Sub cmdExit_Click()                ' Closes the device on exit

  End
  
End Sub




Private Sub Form_Load()                         ' Initialize the program

  UpdateDAC

End Sub

Private Sub tmrSN_Timer()

  Dim Packet As PacketStructure, Ret As RetPacketStructure

  OpenDevice                                                                             'GET THE DEVICE'S SERIAL NUMBER.
  Packet.MajorCmd = 11
  Packet.MinorCmd = 10
  Packet.DataLSB = 0
  Packet.DataMSB = 0
  Packet.Length = 0
  Ret = SendPacket(Packet) ' Get the Version infomation
  lblSerNum = "Serial Number: " & ((Ret.B3 * &H1000000) + (Ret.B2 * &H10000) + (Ret.B1 * &H100) + (Ret.B0))
  CloseDevice
  If lblSerNum.Tag <> "" Then                                                    'Show error message from opening device.
    lblSerNum = lblSerNum.Tag
    Exit Sub
  End If

  UpdateDAC                                                                                        'Update the DAC.

End Sub

Private Sub txtCurrent_Change()

  txtCurrent.ForeColor = vbGrayText

  If Len(txtCurrent) = 0 Then Exit Sub
  
  If Trim(Str(Val(txtCurrent))) <> Trim(txtCurrent) Then txtCurrent = Val(txtCurrent)           'has non-numeric chars.
  If Val(txtCurrent) < 0 Then txtCurrent = 0                                                                  'too low.
  If Val(txtCurrent) > 2047 Then txtCurrent = 2047                                                           'too high.
  
  lblMv = Format(txtCurrent / 2047 * 100, "####0.0") + "mA"
  
End Sub


Private Sub txtCurrent_KeyDown(KeyCode As Integer, Shift As Integer)

  Select Case KeyCode
    Case vbKeyUp:        txtCurrent = Val(txtCurrent) + 1
    Case vbKeyDown:      txtCurrent = Val(txtCurrent) - 1
    Case vbKeyPageUp:    txtCurrent = Val(txtCurrent) + 10
    Case vbKeyPageDown:  txtCurrent = Val(txtCurrent) - 10
  End Select
    
  UpdateDAC

End Sub


